package outils;

public class ListeTableau<Type> implements Liste<Type> {
    private Object contenu[];
    private int nbElem;
    public ListeTableau() {
        contenu = new Object[5];
        nbElem = 0;
    }
    @Override
    public boolean estVide() {
        return nbElem == 0;
    }
    @Override
    public int nombreDElements() {
        return nbElem;
    }
    @Override
    public void ajoute(Type element) {
    	if (nbElem == contenu.length) {
    		Object nouveauContenu[] = new Object[2 * contenu.length];
    		for(int i = 0; i < nbElem; i++) nouveauContenu[i] = contenu[i];
    		contenu = nouveauContenu;
    	}
        contenu[nbElem] = element;
        nbElem++;
    }
    @Override
    public void retire(int index) {
//      if(index < 0 || index >= nbElem) return;
        int i, iSuivant;
        for (i = index, iSuivant = index + 1; i < nbElem - 1; i++, iSuivant++) {
            contenu[i] = contenu[iSuivant];
        }
        nbElem--;
    }
    @Override
    public Type element(int index) {
//        if(index < 0 || index >= nbElem) return null;
        return (Type)(contenu[index]);
    }
}
